#pragma plain

/*
	@@ICONID	431
*/

int main()
{
	LinkList	lks		= linklist::alloc ();
	Link		lk;
	String		str		= string::alloc ();
	String		entry	= string::alloc ();
	int 		olen;
	int 		id;
	
	// Remove all old entries
	//
	frame::replace (gFrame, "");
	
	// Collect all hyperlinks of all documents of the book
	//
	hyperlink::find (
				lks,		// Result list
				0,			// Current document
				"",			// Ignore the cross-reference name
				3,			// Search for 'Product's only
				0, 0, 0, "",
				1,			// Search the entire book
				1, 1, 1, 1,	// Formatting the page names
				1,			// We need the xy co-ordinates to sort the results
				0);			// sort col wise
			
	for (lk = linklist::first (lks); lk != 0; lk = linklist::next (lks))
    {
    	// Get the document text at the destination
    	//
    	frame::gettext (
				link::crossref::frame (lk), 
				str,
				link::crossref::src_textpos (lk)+1, 
				link::crossref::src_textlen (lk)-1);
		
		if (link::crossref::type (lk) == 0 && string::length (str))
		{
			// Remember the current insertion point.
			// We need this so that we can position 
			// the hyperlink correctly.
			//
			olen 	= frame::textlength (gFrame);
			
			id = placeholder::get_value (link::crossref::frame (lk), "ID", link::crossref::pos (lk)+1);
			
			// Insert the toc entry text
			//
			string::set (entry, "%!TT");
			if (olen > 0) 	
			{
				string::append (entry, "<ParaStyle:TOC-Entry>");
				if (id % 100 == 0) string::append (entry, "<ParaStyle:TOC-Entry>");
			}
			
			if (id % 100 == 0)
			{		
				string::append (entry, "<ParaStyle:TOC-Entry><CharStyle:Bold>%s\t%d<CharStyle:>", str, link::crossref::page (lk, 0));
			}
			else
			{
				string::append (entry, "<ParaStyle:TOC-Entry>%s\t%d", str, link::crossref::page (lk, 0));

			}
			frame::append (gFrame, entry);
			
			// Link the toc entry to the destination
			//
			if (id % 100 == 0)
			{
				int 	pp	= olen;
				
				if (olen > 0) pp += 2;
				
				hyperlink::create_pagedest (
					0, 0, 
					gFrame, 
					pp, -1,
					link::crossref::document (lk, 0),
					link::crossref::page (lk, 1));
			}
			else
			{
				hyperlink::create_textdest (
					0, 0, 
					gFrame, 
					olen + 1, -1,
					link::crossref::hyperlink_ref (lk));
			}
		}
    }
    
    string::release (str);
    string::release (entry);
	linklist::release (lks);
	
    return 0;
}
